Foreman - Bug #7038

PGError when hostgroup name exceeds 245 characters
08/12/2014 05:59 AM - Dominic Cleal

Status: Closed
Priority: Normal
Assignee: Ori Rabin
Category: Database
Target version: 1.7.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: 1129202 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/1701
Description

Cloned from https://bugzilla.redhat.com/show_bug.cgi?id=1129202

Description of problem:

| was trying to validate the hostgroup form and found that if we enter more than 245 chars in 'Name' field of hostgroup, It raises
PGError:

Processing by HostgroupsController#update as HTML

Parameters: {"utf8"=>"l", "authenticity_token"=>"8YKMIr6xgzHyJpwHOLC3VbHzoQSwOk+VOG2XoHOFhIiE=",
"hostgroup"=>{"name"=>"SSTQOPqJiwFIILmBmDRZoWsarPNwQhcEypKFfTozMHnmPtTgkgebNCMSMxBdywiWmEbraUdMnjnSivd
KFeioxAgvPTutMitBTTRExegkJRTzxIAHDlasfiwEAabNhzvevKiTDbYXbaqVFArexnApWfavHFpPSoDothzHWKVZOYrqGtSicQxHHrB
oLcuNwrANGduNLMCurtGjlrkweKZNVgDaxmOPfvHBQjwapFpfbhLxGPksMwxGn1", "environment_id"=>"", "content_source_id"=>"",
"puppet_ca_proxy_id"=>"", "puppet_proxy_id"=>"", "domain_id"=>"", "realm_id"=>"", "architecture_id"=>"",
"root_pass"=>"[FILTERED]", "location_ids"=>[""], "organization_ids"=>[""]}, "kt_environment_id"=>"", "kt_activation_keys"=>"",
"commit"=>"Submit",
"id"=>"16-sstqopgjiwfllmbmdrzowsarpnwghceypkfftozmhnmpttgkgebncmsmxbdywiwmebraudmnjnsivdkfeioxagvptutmitbttrexegkjrtzxI
ahdiasfjweaabnhzvevkitdbyxbagvfarexnapwfavhfppsodothzhwkvzoyrggtsicgxhhrbolcunwrangdunimcurtgjlrkwekznvgdaxmopfvhbgjwa
pfpfbhixgpksmwxgn"}

Operation FAILED: PGError: ERROR: value too long for type character varying(255)

: UPDATE "lookup_values" SET "match" =
'hostgroup=SSTQOPqJiwFIILmBmDRZoWsarPNwQhcEypKFfTozMHnmPtTgkgebNCMSMxBdywiWmEbraUdMnjnSIvdKFeioxAgvPT
utMitBTTRExegkJRTzxIAHDIlasfiwEAabNhzvevKiTDbY XbaqVFArexnApWfavHFpPSoDothzHWKVZOYrqGtSicQxHHrBoLcuNwrANG
duNLMCurtGjlrkweKZNVgDaxmOPfvHBQjwapFpfbhLxGPksMwxGn1' WHERE "lookup_values"."match" =
'hostgroup=SSTQOPqJiwFIILmBmDRZoWsarPNwQhcEypKFfTozMHnmPtTgkgebNCMSMxBdywiWmEbraUdMnjnSIvdKFeioxAgvPT
utMitBTTRExegkJRTzxIAHDIlasfiwEAabNhzvevKiTDbY XbaqVFArexnApWfavHFpPSoDothzHWKVZOYrqGtSicQxHHrBoLcuNwrANG
duNLMCurtGjlrkweKZNVgDaxmOPfvHBQjwapFpfbhLxGPksMwxGn'

Rendered common/500.html.erb within layouts/application (5.7ms)

Rendered layouts/base.html.erb (1.4ms)

Completed 500 Internal Server Error in 67ms (Views: 9.7ms | ActiveRecord: 8.1ms)

Version-Release number of selected component (if applicable):
sat6 GA snap4

How reproducible:
always

Steps to Reproduce:

1. create hostgroup with more than 245 char in name
2.

3.

Actual results:
Operation FAILED: PGError: ERROR: value too long for type character varying(255)

Expected results:
User should be allowed to enter 255 char in name field and if it exceeds 255 char then Ul should throw a clean validation error
instead of PGError

Additional info:

Related issues:

Related to Foreman - Bug #6694: PGError: while creating OS with long (greater... Closed 07/20/2014
Related to Foreman - Bug #7437: PGError when host group title is exactly 256 ... Closed 09/15/2014
Related to Foreman - Refactor #7439: Host group name limited because lookup_v... New 09/15/2014
Related to Foreman - Bug #7624: location and organization char names are capp... Closed 09/24/2014

Associated revisions

Revision 5fbe760e - 09/15/2014 04:56 AM - Ori Rabin

Fixes #7038: No error when hostgroup name exceeds 245 characters

Revision 9b0b7bf6 - 09/18/2014 06:33 AM - Dominic Cleal

refs #7038 - use n_() for plural support, use Rails style length message

History

#1 - 08/12/2014 05:59 AM - Dominic Cleal
- Category set to Database

- Priority changed from Low to Normal

Note that this isn't actually the host group name field causing the problem, it's the smart matchers (lookup_values).

#2 - 08/13/2014 06:49 AM - Ori Rabin

- Related to Bug #6694: PGError: while creating OS with long (greater than 5 chars) minor/major version values added

#3 - 08/13/2014 06:58 AM - Ori Rabin
- Status changed from New to Resolved

- Assignee set to Ori Rabin

This was resolved when #6694 was fixed

#4 - 08/13/2014 06:59 AM - Dominic Cleal

Are you sure? | was able to reproduce the problem here on a nightly RPM installation. Note that it's the lookup_values causing the problem, not the
name attribute of the hostgroup.

#5 - 08/13/2014 07:16 AM - Ori Rabin

- Status changed from Resolved to Assigned

#6 - 08/18/2014 04:16 AM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Target version setto 1.7.5

- Pull request https://github.com/theforeman/foreman/pull/1686 added
- Pull request deleted ()

#7 - 08/20/2014 06:33 AM - Ori Rabin
- Pull request https://github.com/theforeman/foreman/pull/1701 added
- Pull request deleted (https://github.com/theforeman/foreman/pull/1686)

#8 - 08/20/2014 06:51 AM - Anonymous

- Target version changed from 1.7.5 to 1.7.4

#9 - 09/10/2014 07:22 AM - Anonymous

- Target version changed from 1.7.4 to 1.7.3
#10 - 09/15/2014 05:03 AM - Ori Rabin
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 5tbe760e04c27400c054c6260f6ffcfec72c2c8e.

#11 - 09/15/2014 05:06 AM - Dominic Cleal

- translation missing: en.field_release set to 21

#12 - 09/15/2014 06:51 AM - Dominic Cleal
- Related to Bug #7437: PGError when host group title is exactly 256 characters added

#13 - 09/15/2014 07:46 AM - Ori Rabin

The error is a result of the lookup_value matchers that are created using the host title.
In the lookup_value table 'match’ is a string column and | couldn't change it to text because there is an index on it.
Mysql doesn't really allow indexes on text columns, there is a workaround that didn't work for match.

To fix the error, the host name is now restricted so that it's title will not cause the matcher to be longer then 255 characters.

If there is a fix for the "'match’” attribute it will be a better fix to turn it into a text column and remove the restriction

#14 - 09/15/2014 07:57 AM - Ori Rabin

- Related to Refactor #7439: Host group name limited because lookup_value ‘match’ is a string added

#15 - 09/28/2014 09:45 AM - Ori Rabin

- Related to Bug #7624: location and organization char names are capped to 246 instead of 255 added
